using System;
using System.Configuration;
using System.Net;

namespace ChrisLacey.MobileEmail.Web
{
	/// <summary>
	/// Functions for checking security
	/// </summary>
	public class Security
	{
		public Security()
		{
		}



		/// <summary>
		/// Returns TRUE if the necessary security criteria have been met
		/// </summary>
		/// <param name="enteredPassword"></param>
		/// <param name="hostName"></param>
		/// <returns></returns>
		public static bool SecurityCheck(string enteredPassword, string host) 
		{
			// Check Password
			string password = ConfigurationSettings.AppSettings["Password"];
			if (password != "" && enteredPassword != password) 
			{
				return false;
			}

			// See if it's necessary to check the client
			if (ConfigurationSettings.AppSettings["Clients"] == "") 
			{
				return true;
			}

			// Check client
			string[] clients = ConfigurationSettings.AppSettings["Clients"].Split(';');
			bool clientPermitted = false;
			string hostName = Dns.Resolve(host).HostName;
			foreach (string client in clients) 
			{
				if (hostName.IndexOf(client) >= 0)
				{
					clientPermitted = true;
				}
			}
			return clientPermitted;
		}
	}
}
