using System;
using System.Collections;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.IO;
using System.Net;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Chilkat;

namespace ChrisLacey.MobileEmail.Web
{
	/// <summary>
	/// Summary description for compose.
	/// </summary>
	public class compose : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox TextBox2;
		protected System.Web.UI.WebControls.TextBox TextBox3;
		protected System.Web.UI.WebControls.TextBox TextBox4;
		protected System.Web.UI.WebControls.TextBox to;
		protected System.Web.UI.WebControls.TextBox cc;
		protected System.Web.UI.WebControls.TextBox bcc;
		protected System.Web.UI.WebControls.TextBox re;
		protected System.Web.UI.WebControls.TextBox subject;
		protected System.Web.UI.WebControls.TextBox body;
		protected System.Web.UI.WebControls.Button send;
		protected System.Web.UI.WebControls.TextBox TextBox5;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Check security
			string password = Request.QueryString["pw"];
			if (!Security.SecurityCheck(password, Page.Request.ServerVariables["REMOTE_ADDR"]))
			{
				Response.End();
			}


			if (Request.QueryString["re"] != null) 
			{
				this.re.Text = Request.QueryString["re"].ToString();
			}
			if (Request.QueryString["subject"] != null) 
			{
				this.subject.Text = Request.QueryString["subject"].ToString();
			}
			if (Request.QueryString["to"] != null) 
			{
				this.to.Text = Request.QueryString["to"].ToString();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.send.Click += new System.EventHandler(this.send_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void send_Click(object sender, System.EventArgs e)
		{
			// Initialise Mail component
			MailMan mailMan = new MailMan();
			mailMan.UnlockComponent("AAWSNETMAIL_aeOU05Jh4Wmt");
			mailMan.MailHost = System.Configuration.ConfigurationSettings.AppSettings["PopServer"];
			mailMan.PopUsername = System.Configuration.ConfigurationSettings.AppSettings["PopUsername"];
			mailMan.PopPassword = System.Configuration.ConfigurationSettings.AppSettings["PopPassword"];
			mailMan.SmtpHost = ConfigurationSettings.AppSettings["SmtpServer"];
			mailMan.SmtpUsername = ConfigurationSettings.AppSettings["SmtpUsername"];
			mailMan.SmtpPassword = ConfigurationSettings.AppSettings["SmtpPassword"];

			// Construct signature
			string signature = "";
			if (File.Exists(Server.MapPath("signature.txt"))) 
			{
				using (StreamReader streamReader = new StreamReader(Server.MapPath("signature.txt"))) 
				{
					signature = streamReader.ReadToEnd();
					streamReader.Close();
				}
			}

			// Construct Email Body
			Email email;
			if (this.re.Text != String.Empty) 
			{
				Email reEmail = mailMan.FetchEmail(this.re.Text);
				email = reEmail.CreateReply();
				email.Body = String.Format("{0}{1}\n\n{2}", this.body.Text, signature, email.Body);
			}
			else 
			{
				email = new Email();
				email.Body = String.Format("{0}{1}", this.body.Text, signature);
			}

			// Set Email properties
			email.FromAddress = ConfigurationSettings.AppSettings["FromAddress"];
			email.FromName = ConfigurationSettings.AppSettings["FromName"];
			email.ClearTo();
			email.AddMultipleTo(this.to.Text);
			email.ClearCC();
			email.AddMultipleCC(this.cc.Text);
			email.ClearBcc();
			email.AddMultipleBcc(this.bcc.Text);
			if (ConfigurationSettings.AppSettings["PersistentBcc"] != String.Empty) 
			{
				email.AddMultipleBcc(ConfigurationSettings.AppSettings["PersistentBcc"]);
			}
			email.Subject = this.subject.Text;

			// Send Email
			mailMan.SendEmail(email);

			// Bounce back to Inbox
			Response.Redirect("inbox.aspx?pw=" + Request.QueryString["pw"]);
		}
	}
}
