using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Chilkat;

namespace ChrisLacey.MobileEmail.Web
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class Inbox : System.Web.UI.Page
	{
		int FETCH_BATCH_SIZE = int.Parse(System.Configuration.ConfigurationSettings.AppSettings["FetchBatchSize"]);
		int MESSAGES_PER_PAGE = int.Parse(System.Configuration.ConfigurationSettings.AppSettings["MessagesPerPage"]);

		protected System.Web.UI.WebControls.Label Label1;
		static MailMan mailMan;

		private void Page_Load(object sender, System.EventArgs e)
		{

			int noOfEmails, startIndex;

			// Check security
			string password = Request.QueryString["pw"];
			if (!Security.SecurityCheck(password, Page.Request.ServerVariables["REMOTE_ADDR"]))
			{
				Response.End();
			}

			// Initialise Mail component
			mailMan = new MailMan();
			mailMan.UnlockComponent("AAWSNETMAIL_aeOU05Jh4Wmt");
			mailMan.MailHost = System.Configuration.ConfigurationSettings.AppSettings["PopServer"];
			mailMan.PopUsername = System.Configuration.ConfigurationSettings.AppSettings["PopUsername"];
			mailMan.PopPassword = System.Configuration.ConfigurationSettings.AppSettings["PopPassword"];

			// Get number of Emails on server
			noOfEmails = mailMan.CheckMail();
			
			// Set up from and to indices
			if (Request.QueryString["startAt"] == null) 
			{
				startIndex = noOfEmails - 1;
			} 
			else 
			{
				startIndex = int.Parse(Request.QueryString["startAt"]);
			}
			int endIndex = startIndex - FETCH_BATCH_SIZE + 1;
			if (endIndex < 0) 
			{
				endIndex = 0;
			}

			// Get Email headers
			EmailBundle emailBundle = mailMan.GetHeaders(0, endIndex, startIndex);
			emailBundle.SortByDate(false);

			// Get blocked Email criteria
			string blockedFromAddresses = System.Configuration.ConfigurationSettings.AppSettings["BlockedFromAddresses"];
			string blockedSubjects = System.Configuration.ConfigurationSettings.AppSettings["BlockedSubjects"];

			// Write Email headers
			StringBuilder stringBuilder = new StringBuilder();
			int noRendered = 0;
			int noIgnored = 0;
			int i = startIndex;
			while ((i >= endIndex) && (noRendered < MESSAGES_PER_PAGE)) 
			{
				Email email = emailBundle.GetEmail(startIndex - i);
				
				string fromName = email.FromName;
				if (fromName == String.Empty) 
				{
					fromName = email.FromAddress;
				}
				if (fromName.Length > 20) 
				{
					fromName = fromName.Substring(0,20) + "...";
				}

				string subject = email.Subject;
				if (subject.Length > 20) 
				{
					subject = subject.Substring(0,20) + "...";
				}
				if (subject == String.Empty) 
				{
					subject = "(No subject)";
				}

				if (Regex.IsMatch(email.FromAddress, blockedFromAddresses) && Regex.IsMatch(email.Subject, blockedSubjects)) 
				{
					noIgnored++;
				}
				else 
				{				
					stringBuilder.Append(String.Format("{0}<br><i>{1}</i><br><a href=\"message.aspx?uidl={2}&pw={3}\">{4}</a><br><br>", email.LocalDate, fromName, email.Uidl, password, subject));
					noRendered++;
				}

				i--;
			}

			// Construct label
			this.Label1.Text = String.Format("<b>{0} messages</b> <a href=\"compose.aspx?pw={1}\">[New]</a><br>", noOfEmails, password);
			if (noIgnored > 0) 
			{
				this.Label1.Text += String.Format("({0} ignored)<br>", noIgnored);
			}
			this.Label1.Text += "<br>";
			this.Label1.Text += stringBuilder.ToString();
			if (i > 0) 
			{
				// Show "Previous" link
				this.Label1.Text += String.Format("<a href=\"inbox.aspx?startAt={0}&pw={1}\">&lt;&lt;</a>", i, password);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
