using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Net;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Chilkat;

namespace ChrisLacey.MobileEmail.Web
{
	/// <summary>
	/// Summary description for message.
	/// </summary>
	public class message : System.Web.UI.Page
	{
		const int TRUNCATED_MESSAGE_LENGTH = 1000;

		protected System.Web.UI.WebControls.Label Label1;
		static MailMan mailMan;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			bool truncated = false;
			string uidl = Request.QueryString["uidl"];

			// Check security
			string password = Request.QueryString["pw"];
			if (!Security.SecurityCheck(password, Page.Request.ServerVariables["REMOTE_ADDR"]))
			{
				Response.End();
			}

			// Initialise Mail component
			mailMan = new MailMan();
			mailMan.UnlockComponent("AAWSNETMAIL_aeOU05Jh4Wmt");
			mailMan.MailHost = System.Configuration.ConfigurationSettings.AppSettings["PopServer"];
			mailMan.PopUsername = System.Configuration.ConfigurationSettings.AppSettings["PopUsername"];
			mailMan.PopPassword = System.Configuration.ConfigurationSettings.AppSettings["PopPassword"];

			// Retrieve Email
			Email email = mailMan.FetchEmail(Request.QueryString["uidl"]);

			// Header
			string replySubject;
			if (email.Subject.ToLower().StartsWith("re:")) 
			{
				replySubject = email.Subject;
			}
			else if (email.Subject.ToLower().StartsWith("fw:"))
			{
				replySubject = "RE:" + email.Subject.Substring(3);
			}
			else 
			{
				replySubject = "RE: " + email.Subject;
			}
			string replyUrl = String.Format("compose.aspx?pw={0}&re={1}&subject={2}&to={3}",
				password, Server.UrlEncode(uidl), Server.UrlEncode(replySubject), Server.UrlEncode(email.FromAddress));
			this.Label1.Text = String.Format("{0}<br><i><a href=\"{4}\">{1} ({2})</a></i><br><b>{3}</b><hr>",
				email.LocalDate, email.FromName, email.FromAddress, email.Subject, replyUrl);

			// Body
			string body = email.Body;
			if (body.ToLower().IndexOf("<body>") == -1) 
			{
				body = body.Replace("\n", "<br>");
			}

			// Truncate message
			if (Request.QueryString["show"] != "all") 
			{
				if (body.Length > TRUNCATED_MESSAGE_LENGTH) 
				{
					body = body.Substring(0, TRUNCATED_MESSAGE_LENGTH);
					truncated = true;
				}
			}

			// Write the body to the page
			this.Label1.Text += body;

			// Add a "Full Message" link if appropriate
			if (truncated) 
			{
				this.Label1.Text += String.Format("<br><br><a href=\"message.aspx?uidl={0}&show=all&pw={1}\">Full message</a>", uidl, password);
			}

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
